/***************************************************************************
                          sglwindow.h  -  description
                             -------------------
    begin                : Wed Jan 23 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
    url                  : www.steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SGLWINDOW_H
#define SGLWINDOW_H

#ifdef WIN32
	#include <windows.h>
#endif

#include <GL/gl.h> 
#include <GL/glu.h>

/**
  *@author Andre Stein
  */

#define TEX_X 128
#define TEX_Y 128
const int TEX_ARRAY_SIZE = TEX_X * TEX_Y;

struct sColor
{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
};

class SGLWindow
{
public:
	SGLWindow();
	~SGLWindow();

	void resize(int width, int height);
	void init();
	void update(float frametime);
 	void keyDown(int key);
protected:
	unsigned int textures[2];
	sColor texArrayOne[TEX_X * TEX_Y];
	sColor texArrayTwo[TEX_X * TEX_Y];
	float cubeRotation[2];
	float orbitRotation;
	GLUquadricObj* sphere;

	void updateTexture();
	void drawCube();
	void drawSphere();
};

#endif
